/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2004-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netdevice.h,v 1.2 2005/07/23 13:56:10 roi Exp $
 */

#ifndef _NETDEVICE_H_
#define _NETDEVICE_H_

#include <t_services.h>

/* 
 *  ͥåȥǥХץ
 */

#define TCP_NETDEVICE_RCV_STACK_SIZE	1024	/* TCP NETDEVIDE Υå	*/
#define TCP_NETDEVICE_SND_STACK_SIZE	1024	/* TCP NETDEVIDE Υå	*/

#define TCP_NETDEVICE_RCV_MAIN_PRIORITY	5		/* TCP NETDEVIDE ͥ		*/
#define TCP_NETDEVICE_SND_MAIN_PRIORITY	5		/* TCP NETDEVIDE ͥ		*/

/*
 *  TCP Хåե
 */

#define TCP_NETDEVICE_CEP_SBUF_SIZE	(1024*2)
#define TCP_NETDEVICE_CEP_RBUF_SIZE	(1024*2)

/*
 *  ͥåȥǥХݡֹ
 */
#define	NET_DEVICE_PORTNO	49150

#ifndef _MACRO_ONLY

/*
 *  ֥å
 */
typedef struct netblock {
    unsigned char  command;
    unsigned char  size;
    unsigned char  sub;
    unsigned char  dmy;
    unsigned long  cnt;
    unsigned long  arg1;
    union{
       unsigned long  w;
       unsigned short h[2];
       unsigned char  b[4];
    }arg2;
} NETBLOCK;

typedef struct snetblock {
	NETBLOCK netblock;
	unsigned char arg3[48];
} SNETBLOCK;

#define	NETDEVTYPE_CLIENT   0x80	/* 饤׵ */
#define	NETDEVTYPE_REQRPY   0x40	/* ץ饤׵ */
#define	NETDEVTYPE_RPY      0x20	/* ץ饤 */
#define	NETDEVTYPE_CMASK    0x1f	/* ޥ */

#define	NETDEVICE_READ      1		/* ݡɤ߹ */
#define	NETDEVICE_WRITE     2		/* ݡȽ񤭹 */
#define	NETDEVICE_INT       3		/* ׵ */
#define NETDEVICE_DATA      10		/* ǡ */

/*
 *  Хåե
 */
#define	BUF_SIZE            (16+1)	/* Хåե */

typedef struct netqueue {
	int  head;						/* netqueue head */
	int  tail;						/* netqueue tail */
	int  size;						/* Хåե */
	NETBLOCK *buffer[BUF_SIZE];		/* Хåեꥢ */
} NETQUEUE;

/*
 *  ǡ̿ΰ
 */
#define NETDATALEN          48		/* ǡΰ襵 */

typedef struct dataqueue {
  int  head;
  int  tail;
  char buf[NETDATALEN];
} DATAQUEUE;

/*
 *  ߿
 */
#define	MAX_INT             64		/* ݤ߿ */

#ifdef USE_TCP_NON_BLOCKING

/*
 *  Υ֥å󥰥ΥХåؿ
 */

extern ER callback_nblk_tcp_netdevice (ID cepid, FN fncd, VP p_parblk);

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP Хåե
 */
extern UB tcp_netdevice_cep_sbuf[];
extern UB tcp_netdevice_cep_rbuf[];

/*
 *  
 */
extern void	tcp_netdevice_rcv_task (VP_INT exinf);
extern void tcp_netdevice_snd_task (VP_INT exinf);

/*
 *  ؿΥץȥ
 */
extern void _init_netdevice(void);
extern BOOL NetDeviceActive(void);
extern BOOL NetDeviceRead(unsigned long address, unsigned long size, void * storage);
extern BOOL NetDeviceWrite(unsigned long address, unsigned long size, void * storage);
extern BOOL NetDeviceSetInt(UW no, void (*func)(VP arg));
extern BOOL _net_setup_input_buffer(NETQUEUE *ib);


#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _NETDEVICE_H_ */
