/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2004-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netdevnet.c,v 1.2 2005/10/22 07:36:49 roi Exp $
 */

/* 
 *  ͥåȥǥХޥץ
 */
#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <tinet_config.h>

#include <net/net.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include "netdevice.h"

#define SEND_DATA_SIZE  (sizeof(SNETBLOCK)-sizeof(NETBLOCK)+8)

/*
 *  ؿ
 */
extern const char *itron_strerror (ER ercd);

extern NETQUEUE in_buf;
extern NETQUEUE out_buf;

/*
 *  ѿ
 */
extern BOOL      net_activate;
extern DATAQUEUE data_buf;
extern unsigned  long netdevice_count;
extern BOOL      rcv_flg;
/*
 *  TCP Хåե
 */

UB tcp_netdevice_cep_sbuf[TCP_NETDEVICE_CEP_SBUF_SIZE];
UB tcp_netdevice_cep_rbuf[TCP_NETDEVICE_CEP_RBUF_SIZE];

#ifdef DEVSERV
/*
 *  NETDEVICEС
 */
void monitor(VP_INT exinf)
{
  static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
  T_IPEP    dst;			/* ³		*/
  ER        error;
  SYSTIM	now;
  int       retry;

  dly_tsk(2500);				/* ץȥ륹åΩ夲Ԥ */
  for(;;){
    if ((error = TCP_ACP_CEP(TCP_NETDEVICE_CEPID, TCP_NETDEVICE_REPID, &dst, TMO_FEVR)) != E_OK) {
      syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", TCP_NETDEVICE_CEPID, itron_strerror(error));
      continue;
    }
    _init_netdevice();
    IP2STR(addr, &dst.ipaddr);
    get_tim(&now);
    syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d",
                 TCP_NETDEVICE_CEPID, now / SYSTIM_HZ, addr, dst.portno);
    rcv_flg      = TRUE;		/* ׵ */
    wup_tsk(TCP_NETDEVICE_RCV_TASK);
    net_activate = TRUE;		/* netDevice Active */
#if defined(START_TASKID) && START_TASKID > 0 && START_TASKID < MONTASK
	act_tsk(START_TASKID);
#endif
    monitor_sub(exinf);			/* ˥μ¹ */
    net_activate = FALSE;		/* netDevice Disable */
    if ((error = tcp_sht_cep(TCP_NETDEVICE_CEPID)) != E_OK)
      syslog(LOG_WARNING, "[TDS:%02d RCV] shutdown error: %s",
                 TCP_NETDEVICE_CEPID, itron_strerror(error));
    for(retry = 0 ; rcv_flg && retry < 50 ; retry++){
      dly_tsk(100);				/* Ԥ 5sec */
    }
    if ((error = tcp_cls_cep(TCP_NETDEVICE_CEPID, TMO_FEVR)) != E_OK)
      syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s",
                 TCP_NETDEVICE_CEPID, itron_strerror(error));
    get_tim(&now);
    syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d",
                 TCP_NETDEVICE_CEPID, now / SYSTIM_HZ);
  }
}

#endif

#ifdef ARP_CFG_CALLBACK_DUPLICATED

BOOL arp_callback_duplicated (UB *shost)
{
  static UB shost_addr[sizeof("00:00:00:00:00:00")];

  mac2str(shost_addr, shost);
  syslog(LOG_ERROR, "[NDEVS] IP address duplicated: %s", shost_addr);

  return TRUE;
}

#endif	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */

#ifdef USE_TCP_NON_BLOCKING
/*
 *  ѿ
 */

static T_IPEP	nblk_src = {
					IP_ADDRANY,
					TCP_PORTANY,
				};
static T_IPEP	nblk_dst;
static ER_UINT	nblk_error;

/*
 *  Υ֥å󥰥ΥХåؿ
 */
ER
callback_nblk_tcp_netdevice (ID cepid, FN fncd, VP p_parblk)
{
  static UB addr[sizeof("123.123.123.123")];
  ER  error = E_OK;

  nblk_error = (ER)p_parblk;

  switch (fncd) {
  case TFN_TCP_CON_CEP:
    IP2STR(addr, nblk_dst.ipaddr);
    sig_sem(SEM_TCP_NETDEVICE_NBLK_READY);
    break;

  case TFN_TCP_RCV_BUF:
    if (nblk_error < 0)
      syslog(LOG_NOTICE, "[TCP NETDEVICE CBN] recv buf error: %s", itron_strerror(nblk_error));
    sig_sem(SEM_TCP_NETDEVICE_NBLK_READY);
    break;

  case TFN_TCP_CLS_CEP:
    if (nblk_error < 0)
      syslog(LOG_NOTICE, "[TCP NETDEVICE CBN] close error: %s", itron_strerror(nblk_error));
    sig_sem(SEM_TCP_NETDEVICE_NBLK_READY);
    break;

  case TFN_TCP_RCV_DAT:
    if (nblk_error < 0)
      syslog(LOG_NOTICE, "[TCP NETDEVICE CBN] recv dat error: %s", itron_strerror(nblk_error));
    sig_sem(SEM_TCP_NETDEVICE_NBLK_READY);
    break;

  case TFN_TCP_ACP_CEP:
  case TFN_TCP_SND_DAT:
  case TFN_TCP_GET_BUF:
  case TFN_TCP_SND_OOB:
  default:
    error = E_PAR;
    break;
  }
  return error;
}

/*
 *  TCP NETDEVICE 
 */
#ifdef USE_COPYSAVE_API
void
tcp_netdevice_rcv_task (VP_INT exinf)
{
  ID     tskid;
  int    roff, total, rlen, i;
  UB     *rmsg;
  ER     error;
  SYSTIM time;
  char   *b;

  get_tid(&tskid);
  syslog(LOG_NOTICE, "[TCP NETDEVICE RCV(NBLK, CS):%d,%d] started.", tskid, (ID)exinf);
  while (TRUE) {
    slp_tsk();

    roff = total = 0;
    while (rcv_flg) {
      if ((error = tcp_rcv_buf((ID)exinf, (VP*)&rmsg, TMO_NBLK)) != E_WBLK) {
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] get recv buf error: %s", itron_strerror(error));
        break;
      }

		/* ХåեγλޤԤġ*/
      wai_sem(SEM_TCP_NETDEVICE_NBLK_READY);

      rlen = nblk_error;
      if (rlen > 0) {
        total += rlen;
        for(i = 0 ; rlen > 0 ; rlen--){
          b = (char *)in_buf.buffer[in_buf.tail] + roff;
          *b = rmsg[i++];
          roff++;
          if(roff >= sizeof(NETBLOCK)){
            roff = 0;
            if(!_net_setup_input_buffer(&in_buf))
              break;
          }
        }
      }
      else
        break;
      if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] rel recv buf error: %s", itron_strerror(error));
    }
    rcv_flg = FALSE;
    get_tim(&time);
    syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv total len: %d,  %5d.%03d",
                       total, time / SYSTIM_HZ, time % SYSTIM_HZ);
  }
}

#else	/* of #ifdef USE_COPYSAVE_API */
void
tcp_netdevice_rcv_task (VP_INT exinf)
{
  static UB rmsg[128];
  ID	tskid;
  int	roff, rlen, total, i;
  ER	error;
  SYSTIM	time;
  char *b;

  get_tid(&tskid);
  syslog(LOG_NOTICE, "[TCP NETDEVICE RCV:%d,%d] started.", tskid, (ID)exinf);
  total=roff=0;
  while (TRUE) {
    slp_tsk();

    while (rcv_flg) {
      if ((error = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), TMO_NBLK)) != E_WBLK) {
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv error: %s", itron_strerror(error));
        break;
      }

			/* λޤԤġ*/
      wai_sem(SEM_TCP_NETDEVICE_NBLK_READY);

      rlen = nblk_error;
      if (rlen > 0) {
        total += rlen;
        for(i = 0 ; rlen > 0 ; rlen--){
          b = (char *)in_buf.buffer[in_buf.tail] + roff;
          *b = rmsg[i++];
          roff++;
          if(roff >= sizeof(NETBLOCK)){
            roff = 0;
            if(!_net_setup_input_buffer(&in_buf))
              break;
          }
        }
      }
      else
        break;
    }
    rcv_flg = FALSE;
    get_tim(&time);
    syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv total len: %d,  %5d.%03d",
                       total, time / SYSTIM_HZ, time % SYSTIM_HZ);
  }
}

#endif	/* of #ifdef USE_COPYSAVE_API */
#else	/* of #ifdef USE_TCP_NON_BLOCKING */
/*
 *  TCP NETDEVICE 
 */

#ifdef USE_COPYSAVE_API
void
tcp_netdevice_rcv_task (VP_INT exinf)
{
  UB     *rmsg;
  ID     tskid;
  int    rlen, roff,total, i;
  SYSTIM time;
  ER     error;
  char  *b;

  get_tid(&tskid);
  syslog(LOG_NOTICE, "[TCP NETDEVICE RCV:%d,%d] started.", tskid, (ID)exinf);
  total=roff=0;
  while (TRUE) {
    slp_tsk();

    while (rcv_flg) {
      if ((rlen = tcp_rcv_buf((ID)exinf, (VP*)&rmsg, TMO_FEVR)) < 0) {
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] get recv buf error: %s", itron_strerror(rlen));
        break;
      }
      else if (rlen > 0) {
        total += rlen;
        for(i = 0 ; rlen > 0 ; rlen--){
          b = (char *)in_buf.buffer[in_buf.tail] + roff;
          *b = rmsg[i++];
          roff++;
          if(roff >= sizeof(NETBLOCK)){
            roff = 0;
            if(!_net_setup_input_buffer(&in_buf))
              break;
          }
        }
      }
      else
        break;
      if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] rel recv buf error: %s", itron_strerror(error));
    }
    rcv_flg = FALSE;
    get_tim(&time);
    syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);
  }
}

#else	/* of #ifdef USE_COPYSAVE_API */
void
tcp_netdevice_rcv_task (VP_INT exinf)
{
  static UB rmsg[128];
  ID     tskid;
  int    rlen, roff,total, i;
  SYSTIM time;
  char   *b;

  get_tid(&tskid);
  syslog(LOG_NOTICE, "[TCP NETDEVICE RCV:%d,%d] started.", tskid, (ID)exinf);
  total=roff=0;
  while (TRUE) {
    slp_tsk();

    while (rcv_flg) {
      if ((rlen = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), TMO_FEVR)) < 0) {
        syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv error: %s", itron_strerror(rlen));
        break;
      }
      else if (rlen > 0) {
        total += rlen;
        for(i = 0 ; rlen > 0 ; rlen--){
          b = (char *)in_buf.buffer[in_buf.tail] + roff;
          *b = rmsg[i++];
          roff++;
          if(roff >= sizeof(NETBLOCK)){
            roff = 0;
            if(!_net_setup_input_buffer(&in_buf)){
              break;
            }
          }
        }
      }
      else
        break;
    }
    rcv_flg = FALSE;
    get_tim(&time);
    syslog(LOG_NOTICE, "[TCP NETDEVICE RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);
  }
}

#endif	/* of #ifdef USE_COPYSAVE_API */
#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP NETDEVICE 
 */

void
tcp_netdevice_snd_task (VP_INT exinf)
{
  int      no, i, len;
  ID       tskid;
  NETBLOCK * sbuf;
  char     * b;

  get_tid(&tskid);
  syslog(LOG_NOTICE, "[TCP NETDEVICE SND:%d,%d] started.", tskid, (ID)exinf);
  _init_netdevice();
  while (TRUE) {
    twai_sem(SEMID_TCP_SEND_WAIT, 500);
    if(net_activate){
      while(data_buf.head != data_buf.tail){
        len = out_buf.tail - out_buf.head;
        if(len < 0)
          len += out_buf.size;
        if(len >= (out_buf.size-4))
          break;
        wai_sem(SEMID_NETQUEUE);
        sbuf = out_buf.buffer[out_buf.tail++];
        sbuf->command = NETDEVTYPE_CLIENT|NETDEVICE_DATA;
        sbuf->size    = sizeof(SNETBLOCK);
        sbuf->cnt     = htonl(++netdevice_count);
        b = (char *)&sbuf->arg1;
        for(i = 0 ; data_buf.head != data_buf.tail && i < SEND_DATA_SIZE ; i++){
          *b++ = data_buf.buf[data_buf.head++];
          if(data_buf.head >= NETDATALEN)
            data_buf.head = 0;
        }
        sbuf->sub     = i;
        if(out_buf.tail >= out_buf.size)
          out_buf.tail = 0;
        sig_sem(SEMID_NETQUEUE);
      }
      if(out_buf.head != out_buf.tail){
        sbuf = out_buf.buffer[out_buf.head];
        if ((no = tcp_snd_dat((ID)exinf, sbuf, sbuf->size, TMO_FEVR)) < 0) {
          syslog(LOG_NOTICE, "[TCP NETDEVIDE SND] send error: %s", itron_strerror(no));
        }
        else{
          if(++out_buf.head >= out_buf.size)
            out_buf.head = 0;
          if(out_buf.head != out_buf.tail)
            sig_sem(SEMID_TCP_SEND_WAIT);
        }
      }
    }
  }
}

