/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task_expansion.h,v 1.3 2007/07/18 17:16:45 roi Exp $
 */

/*
 *	˥ѥѳĥ
 */

#ifndef _TASK_EXPANSION_H_
#define _TASK_EXPANSION_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "kernel_debug.h"
#include <t_services.h>

/*
 *  ֡ʴʰǡˤΥѥåȷ
 */

typedef struct t_rtst{
	STAT    tskstat;			/*  */
	STAT    tskwait;			/* Ԥװ */
	PRI     tskpri;				/* θߤͥ */
	FP      tskpc;				/* θߤΥץ५ */
	VP      tsksp;				/* θߤΥåݥ */
	VP      inistk;				/* Υåɥ쥹 */
	SIZE    inistksz;			/* Υå */
}T_RTST;

#define	TTW_OTHR	0x0040		/* ¾Ԥ */
					/* TOPPERSԤTTW_SEM,TTW_FLG, TTW_SDTQ */
					/* TTW_MBX, TTW_MPFԤֶ̤ǤϤʤ */

/*
 *  ޥե֤Υѥåȷ
 */
typedef struct t_rsem {
	ID      wtskid;				/* ޥեԤƬΥIDֹ */
	UINT    semcnt;				/* ޥեθߤλ񸻿 */
}T_RSEM;

/*
 *  ǡ塼֤Υѥåȷ
 */
typedef struct t_rdtq{
	ID      stskid;				/* ǡ塼ԤƬΥIDֹ */
	ID      rtskid;				/* ǡ塼μԤƬΥIDֹ */
	UINT    sdtqcnt;			/* ǡ塼äƤǡο */
}T_RDTQ;

/*
 *  μ¹Ծֹ¤
 */
#define	MAX_TASK_LOG	8		/* ơ֥ο */
#define	ANA_STIC		10		/* ֥å */

typedef struct t_tlog{
	INT		runcount;			/* μ¹Բ */
	SYSTIM	runtimes;			/* μ¹Ի(MS) */
}T_TLOG;

/*
 *  ΥФ¤
 */

#define	NUM_LDSP		6		/* ɽѤΥФΰκ */

typedef struct t_tprm{
	SYSTIM  pervtime;			/* λȻ */
	SYSTIM  currtime;			/* λȻ */
	T_TLOG	tlog[NUM_LDSP];		/* Ф */
}T_TPRM;

/*
 *  ǥХݡȽơ֥ι¤
 */

#define	NUM_PCHK		4		/* ǥХݡȽơ֥Υƥ */

typedef struct t_pchk{
	UB		logtype;			/* ɽȽ */
	UW		portaddress;		/* ݡȥɥ쥹 */
}T_PCHK;

/*
 *  ץȥ
 */

extern ER isus_tsk(ID tskid);
extern ER ref_tst(ID tskid, T_RTST *pk_rtst);
extern ER ref_sem(ID semid, T_RSEM *pk_rsem);
extern ER ref_dtq(ID dtqid, T_RDTQ *pk_rdtq);
extern void iana_tsk(void);
extern void ana_rdv(UW address, UW data, INT size);
extern void ana_wdv(UW address, UW data, INT size);
extern INT  get_tsklog(T_TPRM *pprm);
extern T_PCHK *get_device_log(UW no);

#ifdef __cplusplus
}
#endif

#endif /* _TASK_EXPANSION_H_ */

